#include <avr/io.h>
#include "Pin.hpp"

class EinAus: public OutputPin {
public:
    EinAus(volatile uint8_t* ddr, volatile uint8_t* port, 
           volatile uint8_t* pin, uint8_t num):
        OutputPin(ddr, port, pin, num) {}
    void ein(void) { this->setHigh(); }
    void aus(void) { this->setLow(); }
};

class Eingabe: public InputPin {
public:
    Eingabe(volatile uint8_t* ddr, volatile uint8_t* port, 
           volatile uint8_t* pin, uint8_t num):
        InputPin(ddr, port, pin, num) {}
    int gedrueckt(void) { return this->isHigh(); }
};

class Getriebe: public InputPin {
public:
    Getriebe(volatile uint8_t* ddr, volatile uint8_t* port, 
           volatile uint8_t* pin, uint8_t num):
        InputPin(ddr, port, pin, num) {}
    int eingelegt(void) { return this->isHigh(); }
};

int main(void) {

    EinAus motor       = EinAus(&DDRB, &PORTB, &PINB, PB1);
    EinAus beleuchtung = EinAus(&DDRB, &PORTB, &PINB, PB2);

    Eingabe startknopf = Eingabe(&DDRD, &PORTD, &PIND, PD1);
    Eingabe bremse     = Eingabe(&DDRD, &PORTD, &PIND, PD2);

    Getriebe gang      = Getriebe(&DDRD, &PORTD, &PIND, PD3);

    while(1) {
        if (startknopf.gedrueckt()) { 
            beleuchtung.ein();
            if (gang.eingelegt() and bremse.gedrueckt()) {
                motor.ein();
            }
        } else { 
            motor.aus();
            beleuchtung.aus();
        }
    }
}
